#include <Navigation/libraries/server/event_publishing/MemoryPublisher.h>


void
armarx::nav::server::MemoryPublisher::goalReached(const core::GoalReachedEvent& event)
{
    eventsWriter->store(event, clientId);
}


void
armarx::nav::server::MemoryPublisher::waypointReached(const core::WaypointReachedEvent& event)
{
    eventsWriter->store(event, clientId);
}


void
armarx::nav::server::MemoryPublisher::safetyThrottlingTriggered(
    const core::SafetyThrottlingTriggeredEvent& event)
{
    // eventsWriter->store(event, clientId);
}


void
armarx::nav::server::MemoryPublisher::safetyStopTriggered(
    const core::SafetyStopTriggeredEvent& event)
{
    // eventsWriter->store(event, clientId);
}


void
armarx::nav::server::MemoryPublisher::userAbortTriggered(const core::UserAbortTriggeredEvent& event)
{
    // eventsWriter->store(event, clientId);
}


void
armarx::nav::server::MemoryPublisher::internalError(const core::InternalErrorEvent& event)
{
    eventsWriter->store(event, clientId);
}

namespace armarx::nav::server
{
    void
    MemoryPublisher::globalTrajectoryUpdated(const glob_plan::GlobalPlannerResult& res)
    {
        resultWriter->store(res, clientId);
    }

    void
    MemoryPublisher::localTrajectoryUpdated(const loc_plan::LocalPlannerResult& res)
    {
        // TODO resultWriter->store(res, clientId);
    }

    void
    MemoryPublisher::trajectoryControllerUpdated(const traj_ctrl::TrajectoryControllerResult& res)
    {
        resultWriter->store(res, clientId);
    }

    // TODO event with message or reason (enum)
    void
    MemoryPublisher::globalPlanningFailed(const core::GlobalPlanningFailedEvent& event)
    {
        eventsWriter->store(event, clientId);
    }

    void
    MemoryPublisher::movementStarted(const core::MovementStartedEvent& event)
    {
        eventsWriter->store(event, clientId);
    }

    MemoryPublisher::MemoryPublisher(armarx::nav::mem::client::stack_result::Writer* resultWriter,
                                     armarx::nav::mem::client::events::Writer* eventsWriter) :
        resultWriter(resultWriter), eventsWriter(eventsWriter)
    {
    }
} // namespace armarx::nav::server
